<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>PacketStamper Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="class_packet_stamper-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PacketStamper Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Supplies functionality for timestamping data packets.  
 <a href="class_packet_stamper.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a547d3beb2bbf533f774e4f674eb61bdc"><td class="memItemLeft" align="right" valign="top">static int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#a547d3beb2bbf533f774e4f674eb61bdc">calculateLargePacketCounter</a> (int64_t frameCounter, int64_t lastCounter, int64_t boundary)</td></tr>
<tr class="memdesc:a547d3beb2bbf533f774e4f674eb61bdc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the new large packet counter value based on <em>frameCounter</em> and the <em>lastCounter</em>.  <a href="#a547d3beb2bbf533f774e4f674eb61bdc">More...</a><br /></td></tr>
<tr class="separator:a547d3beb2bbf533f774e4f674eb61bdc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d91966f23ad9c4f74a9bec9f8386b49"><td class="memItemLeft" align="right" valign="top">static int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#a3d91966f23ad9c4f74a9bec9f8386b49">calculateLargeSampleTime</a> (int64_t frameTime, int64_t lastTime)</td></tr>
<tr class="memdesc:a3d91966f23ad9c4f74a9bec9f8386b49"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the new large sample time value based on <em>frameTime</em> and the <em>lastTime</em>.  <a href="#a3d91966f23ad9c4f74a9bec9f8386b49">More...</a><br /></td></tr>
<tr class="separator:a3d91966f23ad9c4f74a9bec9f8386b49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7ad976f25b3a8ef5c9238c8ce4bcffe"><td class="memItemLeft" align="right" valign="top">static int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#ad7ad976f25b3a8ef5c9238c8ce4bcffe">stampPacket</a> (<a class="el" href="struct_xs_data_packet.html">XsDataPacket</a> &amp;pack, <a class="el" href="struct_xs_data_packet.html">XsDataPacket</a> &amp;highest)</td></tr>
<tr class="memdesc:ad7ad976f25b3a8ef5c9238c8ce4bcffe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create 64 bit counter for a packet.  <a href="#ad7ad976f25b3a8ef5c9238c8ce4bcffe">More...</a><br /></td></tr>
<tr class="separator:ad7ad976f25b3a8ef5c9238c8ce4bcffe"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a57d9c91febc07eb7105316659487791d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a57d9c91febc07eb7105316659487791d"></a>
static const int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#a57d9c91febc07eb7105316659487791d">AWINDABOUNDARY</a> = 0x100000000LL</td></tr>
<tr class="memdesc:a57d9c91febc07eb7105316659487791d"><td class="mdescLeft">&#160;</td><td class="mdescRight">32 bit MT Sample Counter boundary <br /></td></tr>
<tr class="separator:a57d9c91febc07eb7105316659487791d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5c7705fdd7a0b092a17a694f13b9d09"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac5c7705fdd7a0b092a17a694f13b9d09"></a>
static const int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#ac5c7705fdd7a0b092a17a694f13b9d09">MTSCBOUNDARY</a> = 0x00010000LL</td></tr>
<tr class="memdesc:ac5c7705fdd7a0b092a17a694f13b9d09"><td class="mdescLeft">&#160;</td><td class="mdescRight">16 bit MT Sample Counter boundary <br /></td></tr>
<tr class="separator:ac5c7705fdd7a0b092a17a694f13b9d09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae6bc193775f2a209e31083a15e8080c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aae6bc193775f2a209e31083a15e8080c"></a>
static const int64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_packet_stamper.html#aae6bc193775f2a209e31083a15e8080c">SC8BOUNDARY</a> = 0x00000100LL</td></tr>
<tr class="memdesc:aae6bc193775f2a209e31083a15e8080c"><td class="mdescLeft">&#160;</td><td class="mdescRight">8 bit Sample Counter boundary <br /></td></tr>
<tr class="separator:aae6bc193775f2a209e31083a15e8080c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Supplies functionality for timestamping data packets. </p>
<p>This class can analyze a data packet and create a proper packet id for it. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a547d3beb2bbf533f774e4f674eb61bdc"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int64_t PacketStamper::calculateLargePacketCounter </td>
          <td>(</td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>frameCounter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>lastCounter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>boundary</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the new large packet counter value based on <em>frameCounter</em> and the <em>lastCounter</em>. </p>
<p>Wraparound is at the given <em>boundary</em> </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">frameCounter</td><td>The frame counter </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">lastCounter</td><td>The last counter </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">boundary</td><td>the boundary at which to assume a wrap-around </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The computed packet counter value </dd></dl>
<dl class="section note"><dt>Note</dt><dd>If lastCounter &lt; 0, returns frameCounter </dd></dl>

</div>
</div>
<a class="anchor" id="a3d91966f23ad9c4f74a9bec9f8386b49"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int64_t PacketStamper::calculateLargeSampleTime </td>
          <td>(</td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>frameTime</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int64_t&#160;</td>
          <td class="paramname"><em>lastTime</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculate the new large sample time value based on <em>frameTime</em> and the <em>lastTime</em>. </p>
<p>Wraparound is at 864000000 (1 day @ 10kHz) </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">frameTime</td><td>The frame time </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">lastTime</td><td>The last time </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The computed packet counter value </dd></dl>
<dl class="section note"><dt>Note</dt><dd>If lastTime &lt; 0, returns frameTime </dd></dl>

</div>
</div>
<a class="anchor" id="ad7ad976f25b3a8ef5c9238c8ce4bcffe"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int64_t PacketStamper::stampPacket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_xs_data_packet.html">XsDataPacket</a> &amp;&#160;</td>
          <td class="paramname"><em>pack</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_data_packet.html">XsDataPacket</a> &amp;&#160;</td>
          <td class="paramname"><em>highestPacket</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create 64 bit counter for a packet. </p>
<p>Wrap when new <a class="el" href="struct_xs_data_packet.html" title="Contains data received from a device or read from a file. ">XsDataPacket</a> is too far away from the previous <a class="el" href="struct_xs_data_packet.html" title="Contains data received from a device or read from a file. ">XsDataPacket</a> in time. Use half cache size as reasonable time difference When infinite cache, simply wrap when new is lower than old </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pack</td><td>The <a class="el" href="struct_xs_data_packet.html" title="Contains data received from a device or read from a file. ">XsDataPacket</a> that needs its 64-bit sample counter updated </td></tr>
    <tr><td class="paramname">highestPacket</td><td>The highest packet available for the current device, it will be updated if the new counter is higher than the stored value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The computed counter for the packet. </dd></dl>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Wed May 17 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
